class SecurenetUtil

	def initialize(id, key, url = "https://gwapi.demo.securenet.com/api")
		@id = id
		@key = key
		@url = url
	end

	def get(path, content)
		url = "#{@url}#{path}"
		response = RestClient::Request.new(
			:method => :get,
			:url => url,
			:user => @id,
			:password => @key,
			:headers => { :accept => :json, :content_type => :json }
		).execute
		results = JSON.parse(response.to_str)
		return results
	end

	def post(path, content)
		url = "#{@url}#{path}"
		response = RestClient::Request.new(
			:method => :post,
			:url => url,
			:payload => content.to_json,
			:user => @id,
			:password => @key,
			:headers => { :accept => :json, :content_type => :json }
		).execute
		results = JSON.parse(response.to_str)
		return results
	end

	def put(path, content)
		url = "#{@url}#{path}"
		response = RestClient::Request.new(
			:method => :put,
			:url => url,
			:payload => content.to_json,
			:user => @id,
			:password => @key,
			:headers => { :accept => :json, :content_type => :json }
		).execute
		results = JSON.parse(response.to_str)
		return results
	end

	def delete(path, content)
		url = "#{@url}#{path}"
		response = RestClient::Request.new(
			:method => :delete,
			:url => url,
			:payload => content.to_json,
			:user => @id,
			:password => @key,
			:headers => { :accept => :json, :content_type => :json }
		).execute
		results = JSON.parse(response.to_str)
		return results
	end

	def error(message)
		return {
			:message => message,
			:success => false,
			:result => "COMMUNICATION_ERROR"
		}
	end

end
